From e7afef62b872be09f58e4cf8eb991deaa8ef080b Mon Sep 17 00:00:00 2001
From: Houston Hoffman <hhoffman@codeaurora.org>
Date: Wed, 1 Mar 2017 20:02:28 -0800
Subject: [PATCH] qcacmn: Squashed Change of wlan driver common fixes

qcacmn: Squashed Change of following changes on top of
Based-on-changeid: I0c8a398828ffeb6c8e6d3293c05b39eb7250191f
Based-on-commitid: commit 9553242bae763ac2185f06346e1afe99530a2bd8

qcacmn: Support oom recovery for rx ce's
OrigChange-Id: I047818145dbe230fefc447b6b034705f9b87ca70
CRs-Fixed: 2015778

qcacmn: Increase wmi ce rx ring size
OrigChange-Id: I2e9a6caeee10f317bd3d70b770fcae3ad2d96623
OrigCRs-Fixed: 2015778

qcacmn: Remove CONFIG_CNSS ifdef for memory proallocatation
OrigChange-Id: I233f6f31065c2d1da1ffb25a5013a17ac0b99246
OrigCRs-Fixed: 2016844

qcacmn: Use magic pattern to avoid double free of packets
OrigChange-Id: I4e010c2e2571398e4f7423162162cf0d2206d18b
OrigCRs-Fixed: 2016682

qcacmn: Fix preallocation perf build compilation error
OrigChange-Id: I17b4ae2cd65658e961bf7aa37518635bb94b5a95
OrigCRs-Fixed: 2017447
---
 hif/src/ce/ce_assignment.h |  2 +-
 hif/src/ce/ce_internal.h   |  1 +
 hif/src/ce/ce_main.c       | 47 +++++++++++++++++++++++++++++--
 htc/htc_packet.h           | 30 ++++++++++++++++++++
 htc/htc_send.c             |  7 +++--
 qdf/linux/src/qdf_mem.c    | 70 +++++++++++++++++++++++++++++++++++-----------
 6 files changed, 135 insertions(+), 22 deletions(-)

diff --git a/hif/src/ce/ce_assignment.h b/hif/src/ce/ce_assignment.h
index b4bb13d..b7225d2 100644
--- a/hif/src/ce/ce_assignment.h
+++ b/hif/src/ce/ce_assignment.h
@@ -91,7 +91,7 @@ static struct CE_attr host_ce_config_wlan[] = {
 	/* target->host HTT + HTC control */
 	{ /* CE1 */ CE_ATTR_FLAGS, 0, 0,  2048, 512, NULL,},
 	/* target->host WMI */
-	{ /* CE2 */ CE_ATTR_FLAGS, 0, 0,  2048, 64, NULL,},
+	{ /* CE2 */ CE_ATTR_FLAGS, 0, 0,  2048, 128, NULL,},
 	/* host->target WMI */
 	{ /* CE3 */ CE_ATTR_FLAGS, 0, 32, 2048, 0, NULL,},
 	/* host->target HTT */
diff --git a/hif/src/ce/ce_internal.h b/hif/src/ce/ce_internal.h
index c0244b0..70f658d 100644
--- a/hif/src/ce/ce_internal.h
+++ b/hif/src/ce/ce_internal.h
@@ -111,6 +111,7 @@ struct CE_state {
 	fastpath_msg_handler fastpath_handler;
 	void *context;
 #endif /* WLAN_FEATURE_FASTPATH */
+	qdf_work_t oom_allocation_work;
 
 	ce_send_cb send_cb;
 	void *send_context;
diff --git a/hif/src/ce/ce_main.c b/hif/src/ce/ce_main.c
index cdcb6ee..e1cf996 100644
--- a/hif/src/ce/ce_main.c
+++ b/hif/src/ce/ce_main.c
@@ -647,6 +647,26 @@ int hif_ce_bus_late_resume(struct hif_softc *scn)
 	return 0;
 }
 
+/**
+ * ce_oom_recovery() - try to recover rx ce from oom condition
+ * @context: CE_state of the CE with oom rx ring
+ *
+ * the executing work Will continue to be rescheduled untill
+ * at least 1 descriptor is successfully posted to the rx ring.
+ *
+ * return: none
+ */
+static void ce_oom_recovery(void *context)
+{
+	struct CE_state *ce_state = context;
+	struct hif_softc *scn = ce_state->scn;
+	struct HIF_CE_state *ce_softc = HIF_GET_CE_STATE(scn);
+	struct HIF_CE_pipe_info *pipe_info =
+		&ce_softc->pipe_info[ce_state->id];
+
+	hif_post_recv_buffers_for_pipe(pipe_info);
+}
+
 /*
  * Initialize a Copy Engine based on caller-supplied attributes.
  * This may be called once to initialize both source and destination
@@ -1008,6 +1028,9 @@ struct CE_handle *ce_init(struct hif_softc *scn,
 	if (Q_TARGET_ACCESS_END(scn) < 0)
 		goto error_target_access;
 
+	qdf_create_work(scn->qdf_dev, &CE_state->oom_allocation_work,
+			ce_oom_recovery, CE_state);
+
 	/* update the htt_data attribute */
 	ce_mark_datapath(CE_state);
 
@@ -1662,11 +1685,16 @@ static void hif_post_recv_buffers_failure(struct HIF_CE_pipe_info *pipe_info,
 	 *	there is no trigger to refill the ce and we will
 	 *	eventually crash
 	 */
-	if (bufs_needed_tmp == CE_state->dest_ring->nentries - 1)
+	if (bufs_needed_tmp == CE_state->dest_ring->nentries - 1) {
+
 		QDF_ASSERT(0);
+		qdf_sched_work(scn->qdf_dev, &CE_state->oom_allocation_work);
+	}
 }
 
 
+
+
 static int hif_post_recv_buffers_for_pipe(struct HIF_CE_pipe_info *pipe_info)
 {
 	struct CE_handle *ce_hdl;
@@ -1706,8 +1734,7 @@ static int hif_post_recv_buffers_for_pipe(struct HIF_CE_pipe_info *pipe_info)
 		 * CE_data = dma_map_single(dev, data, buf_sz, );
 		 * DMA_FROM_DEVICE);
 		 */
-		ret =
-			qdf_nbuf_map_single(scn->qdf_dev, nbuf,
+		ret = qdf_nbuf_map_single(scn->qdf_dev, nbuf,
 					    QDF_DMA_FROM_DEVICE);
 
 		if (unlikely(ret != QDF_STATUS_SUCCESS)) {
@@ -1944,6 +1971,19 @@ void hif_flush_surprise_remove(struct hif_opaque_softc *hif_ctx)
 	hif_buffer_cleanup(hif_state);
 }
 
+static void hif_destroy_oom_work(struct hif_softc *scn)
+{
+	struct CE_state *ce_state;
+	int ce_id;
+
+	for (ce_id = 0; ce_id < scn->ce_count; ce_id++) {
+		ce_state = scn->ce_id_to_state[ce_id];
+		if (ce_state)
+			qdf_destroy_work(scn->qdf_dev,
+					 &ce_state->oom_allocation_work);
+	}
+}
+
 void hif_ce_stop(struct hif_softc *scn)
 {
 	struct HIF_CE_state *hif_state = HIF_GET_CE_STATE(scn);
@@ -1954,6 +1994,7 @@ void hif_ce_stop(struct hif_softc *scn)
 	 * bottom half contexts will not be re-entered
 	 */
 	hif_nointrs(scn);
+	hif_destroy_oom_work(scn);
 	scn->hif_init_done = false;
 
 	/*
diff --git a/htc/htc_packet.h b/htc/htc_packet.h
index 7d13b40..a6814a4 100644
--- a/htc/htc_packet.h
+++ b/htc/htc_packet.h
@@ -87,6 +87,7 @@ typedef struct _HTC_RX_PACKET_INFO {
 } HTC_RX_PACKET_INFO;
 
 #define HTC_RX_FLAGS_INDICATE_MORE_PKTS  (1 << 0)       /* more packets on this endpoint are being fetched */
+#define HTC_PACKET_MAGIC_COOKIE          0xdeadbeef
 
 /* wrapper around endpoint-specific packets */
 typedef struct _HTC_PACKET {
@@ -124,6 +125,7 @@ typedef struct _HTC_PACKET {
 				can pass the network buffer corresponding to the HTC packet
 				lower layers may optimized the transfer knowing this is
 				a network buffer */
+	uint32_t magic_cookie;
 } HTC_PACKET;
 
 #define COMPLETE_HTC_PACKET(p, status)	     \
@@ -278,4 +280,32 @@ static inline HTC_PACKET *htc_packet_dequeue_tail(HTC_PACKET_QUEUE *queue)
 
 #define HTC_PACKET_QUEUE_ITERATE_END ITERATE_END
 
+/**
+ * htc_packet_set_magic_cookie() - set magic cookie in htc packet
+ * htc_pkt - pointer to htc packet
+ * value - value to set in magic cookie
+ *
+ * This API sets the magic cookie passed in htc packet.
+ *
+ * Return : None
+ */
+static inline void htc_packet_set_magic_cookie(HTC_PACKET *htc_pkt,
+			uint32_t value)
+{
+	htc_pkt->magic_cookie = value;
+}
+
+/**
+ * htc_packet_set_magic_cookie() - get magic cookie in htc packet
+ * htc_pkt - pointer to htc packet
+ *
+ * This API returns the magic cookie in htc packet.
+ *
+ * Return : magic cookie
+ */
+static inline uint32_t htc_packet_get_magic_cookie(HTC_PACKET *htc_pkt)
+{
+	return htc_pkt->magic_cookie;
+}
+
 #endif /*HTC_PACKET_H_ */
diff --git a/htc/htc_send.c b/htc/htc_send.c
index 20e00da..6b86e57 100644
--- a/htc/htc_send.c
+++ b/htc/htc_send.c
@@ -623,10 +623,12 @@ static A_STATUS htc_issue_packets(HTC_TARGET *target,
 		UNLOCK_HTC_TX(target);
 
 		hif_send_complete_check(target->hif_dev, pEndpoint->UL_PipeID, false);
+		htc_packet_set_magic_cookie(pPacket, HTC_PACKET_MAGIC_COOKIE);
 		status = hif_send_head(target->hif_dev,
 				       pEndpoint->UL_PipeID, pEndpoint->Id,
 				       HTC_HDR_LENGTH + pPacket->ActualLength,
 				       netbuf, data_attr);
+
 #if DEBUG_BUNDLE
 		qdf_print(" Send single EP%d buffer size:0x%x, total:0x%x.\n",
 			  pEndpoint->Id,
@@ -650,8 +652,9 @@ static A_STATUS htc_issue_packets(HTC_TARGET *target,
 			pEndpoint->ul_outstanding_cnt--;
 			HTC_PACKET_REMOVE(&pEndpoint->TxLookupQueue, pPacket);
 			/* reclaim credits */
-				pEndpoint->TxCredits +=
-					pPacket->PktInfo.AsTx.CreditsUsed;
+			pEndpoint->TxCredits +=
+				pPacket->PktInfo.AsTx.CreditsUsed;
+			htc_packet_set_magic_cookie(pPacket, 0);
 			/* put it back into the callers queue */
 			HTC_PACKET_ENQUEUE_TO_HEAD(pPktQueue, pPacket);
 			UNLOCK_HTC_TX(target);
diff --git a/qdf/linux/src/qdf_mem.c b/qdf/linux/src/qdf_mem.c
index f924925..fc4db07 100644
--- a/qdf/linux/src/qdf_mem.c
+++ b/qdf/linux/src/qdf_mem.c
@@ -722,6 +722,47 @@ qdf_mem_zero_outline(void *buf, qdf_size_t size)
 }
 EXPORT_SYMBOL(qdf_mem_zero_outline);
 
+#ifdef CONFIG_WCNSS_MEM_PRE_ALLOC
+/**
+ * qdf_mem_prealloc_get() - conditionally pre-allocate memory
+ * @size: the number of bytes to allocate
+ *
+ * If size if greater than WCNSS_PRE_ALLOC_GET_THRESHOLD, this function returns
+ * a chunk of pre-allocated memory. If size if less than or equal to
+ * WCNSS_PRE_ALLOC_GET_THRESHOLD, or an error occurs, NULL is returned instead.
+ *
+ * Return: NULL on failure, non-NULL on success
+ */
+static void *qdf_mem_prealloc_get(size_t size)
+{
+	void *mem;
+
+	if (size <= WCNSS_PRE_ALLOC_GET_THRESHOLD)
+		return NULL;
+
+	mem = wcnss_prealloc_get(size);
+	if (mem)
+		memset(mem, 0, size);
+
+	return mem;
+}
+
+static inline bool qdf_mem_prealloc_put(void *ptr)
+{
+	return wcnss_prealloc_put(ptr);
+}
+#else
+static inline void *qdf_mem_prealloc_get(size_t size)
+{
+	return NULL;
+}
+
+static inline bool qdf_mem_prealloc_put(void *ptr)
+{
+	return false;
+}
+#endif /* CONFIG_WCNSS_MEM_PRE_ALLOC */
+
 /* External Function implementation */
 #ifdef MEMORY_DEBUG
 
@@ -858,16 +899,9 @@ void *qdf_mem_malloc_debug(size_t size,
 		return NULL;
 	}
 
-#if defined(CONFIG_CNSS) && defined(CONFIG_WCNSS_MEM_PRE_ALLOC)
-	if (size > WCNSS_PRE_ALLOC_GET_THRESHOLD) {
-		void *pmem;
-		pmem = wcnss_prealloc_get(size);
-		if (NULL != pmem) {
-			memset(pmem, 0, size);
-			return pmem;
-		}
-	}
-#endif
+	mem_ptr = qdf_mem_prealloc_get(size);
+	if (mem_ptr)
+		return mem_ptr;
 
 	if (in_interrupt() || irqs_disabled() || in_atomic())
 		flags = GFP_ATOMIC;
@@ -983,10 +1017,9 @@ void qdf_mem_free(void *ptr)
 		QDF_BUG(0);
 	}
 
-#if defined(CONFIG_CNSS) && defined(CONFIG_WCNSS_MEM_PRE_ALLOC)
-	if (wcnss_prealloc_put(ptr))
+	if (qdf_mem_prealloc_put(ptr))
 		return;
-#endif
+
 	if (!qdf_atomic_dec_and_test(&mem_struct->in_use))
 		return;
 
@@ -1085,6 +1118,11 @@ EXPORT_SYMBOL(qdf_mem_free);
 void *qdf_mem_malloc(size_t size)
 {
 	int flags = GFP_KERNEL;
+	void *mem;
+
+	mem = qdf_mem_prealloc_get(size);
+	if (mem)
+		return mem;
 
 	if (in_interrupt() || irqs_disabled())
 		flags = GFP_ATOMIC;
@@ -1105,10 +1143,10 @@ void qdf_mem_free(void *ptr)
 {
 	if (ptr == NULL)
 		return;
-#if defined(CONFIG_CNSS) && defined(CONFIG_WCNSS_MEM_PRE_ALLOC)
-	if (wcnss_prealloc_put(ptr))
+
+	if (qdf_mem_prealloc_put(ptr))
 		return;
-#endif
+
 	kfree(ptr);
 }
 EXPORT_SYMBOL(qdf_mem_free);
-- 
1.9.1

